#!/bin/sh

SWAP_MUL=1 # swap size multiplicator
SWAP_MAX=$[8*1048576]
ROOT_MIN=$[20*1048576-524288]

# swap ~= RAM (but not more than $SWAP_MAX)
mem="`grep MemTotal /proc/meminfo | sed 's/[^0-9]//g'`"; [ -n "$mem" ] || mem=1048576
swap_size="$[$mem*$SWAP_MUL]"
[ "$swap_size" -gt "$SWAP_MAX" ] && swap_size="$SWAP_MAX"
swap_size=$[$swap_size*21/20] # add 5% to fit hibernation

# Don't use raid under virtualization
if lspci -n | grep -qE '(1013:00b8)|(80ee:beef)|(14ad:0405)|(1af4:100)' ; then
	server_methods='plain'
	swap_size=131072 # 128M
else
	server_methods='raid plain'
fi

ROOT_MIN=$[$ROOT_MIN-$swap_size] # fit swap into limit

# recalculate in 512-byte blocks for EVMS
swap_size="$[$swap_size*2]"
ROOT_MIN=$[$ROOT_MIN*2]
cat > /var/cache/alterator/vm-profile.scm << _EOF_
(
 (timeshiftstation
  (title . "Setup for workstation (Timeshift compatible)")
  (action . trivial)
  (actiondata  ("" (size $ROOT_MIN . #t ) (fsim . "BtrFS") (methods plain)
                (subvols ("@" . "/") ("@home" . "/home"))
               )
  )
 )
 (workstation
  (title . "Setup for workstation")
  (action . trivial)
  (actiondata  ("/" (size $ROOT_MIN . #t ) (fsim . "Ext2/3") (methods lvm))
  )
 )
 (nolvmstation
  (title . "Setup for workstation (without LVM)")
  (action . trivial)
  (actiondata  ("/" (size $ROOT_MIN . #t ) (fsim . "Ext2/3") (methods plain))
  )
 )
)
_EOF_
